# $Revision: 1.38 $, $Date: 2010/05/14 22:04:08 $
# TODO
# - init script for webserver
# - pldized init script
# - set value for Xmx in sysconfig. Default is too low to run hsqldb server.

%define		ver	%(echo %{version} | tr . _)
%define		srcname	hsqldb
%include	/usr/lib/rpm/macros.java
Summary:	SQL relational database engine written in Java
Summary(pl.UTF-8):	Silnik relacyjnych baz danych SQL napisany w Javie
Name:		java-hsqldb
Version:	1.8.1.1
Release:	2
License:	BSD-like
Group:		Libraries/Java
Source0:	http://downloads.sourceforge.net/hsqldb/%{srcname}_%{ver}.zip
# Source0-md5:	4114ba2e6aba58e6bfd3fa283d7dbc37
Source1:	%{name}-standard.cfg
Source2:	%{name}-standard-server.properties
Source3:	%{name}-standard-webserver.properties
Source4:	%{name}-standard-sqltool.rc
Patch0:		%{name}-scripts.patch
Patch1:		%{name}-pld.patch
Patch2:		%{name}-javadoc.patch
URL:		http://www.hsqldb.org/
BuildRequires:	ant
BuildRequires:	java(servlet)
BuildRequires:	java-junit
%{buildrequires_jdk}
BuildRequires:	jpackage-utils >= 0:1.5
BuildRequires:	rpm-javaprov
BuildRequires:	rpmbuild(macros) >= 1.556
BuildRequires:	sed >= 4.0
BuildRequires:	unzip
Obsoletes:	hsqldb <= 1.8.1.1-1
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
HSQLDB is the leading SQL relational database engine written in Java.
It has a JDBC driver and supports a rich subset of ANSI-92 SQL (BNF
tree format) plus SQL 99 and 2003 enhancements. It offers a small
(less than 100k in one version for applets), fast database engine
which offers both in-memory and disk-based tables and supports
embedded and server modes.

Additionally, it includes tools such as a minimal web server,
in-memory query and management tools (can be run as applets) and a
number of demonstration examples.

%description -l pl.UTF-8
HSQLDB to wiodący silnik relacyjnych baz danych SQL napisany w Javie.
Ma sterownik JDBC i obsługuje znaczny podzbiór ANSI-92 SQL (w formacie
drzew BNF) oraz rozszerzenia SQL 99 i 2003. Oferuje mały (poniżej 100k
w jednej wersji dla apletów), szybki silnik obsługujący tabele zarówno
w pamięci, jak i na dysku; obsługuje tryb wbudowany oraz serwerowy.

Ponadto zawiera narzędzia takie jak minimalny serwer WWW, zapytania w
pamięci i narzędzia zarządzające (mogące działać jako aplety) oraz
wiele przykładów demonstracyjnych.

%package manual
Summary:	Manual for HSQLDB
Summary(pl.UTF-8):	Podręcznik do HSQLDB
Group:		Documentation
Obsoletes:	hsqldb-manual

%description manual
Documentation for HSQLDB.

%description manual -l pl.UTF-8
Podręcznik do HSQLDB.

%package javadoc
Summary:	Javadoc for HSQLDB
Summary(pl.UTF-8):	Dokumentacja javadoc do HSQLDB
Group:		Documentation
Requires:	jpackage-utils
Obsoletes:	hsqldb-javadoc

%description javadoc
Javadoc for HSQLDB.

%description javadoc -l pl.UTF-8
Dokumentacja javadoc do HSQLDB.

%package source
Summary:	Source code of %{srcname}
Summary(pl.UTF-8):	Kod źródłowy %{srcname}
Group:		Documentation
Requires:	jpackage-utils >= 1.7.5-2

%description source
Source code of %{srcname}.

%description source -l pl.UTF-8
Kod źródłowy %{srcname}.

%package demo
Summary:	Demo for HSQLDB
Summary(pl.UTF-8):	Pliki demonstracyjne dla HSQLDB
Group:		Documentation
Requires:	%{name} = %{version}-%{release}
Obsoletes:	hsqldb-demo

%description demo
Demonstrations and samples for HSQLDB.

%description demo -l pl.UTF-8
Programy demonstracyjne i przykładowe dla HSQLDB.

%package -n hsqldb
Summary:	HSQLDB server
Summary(pl.UTF-8):	Serwer HSQLDB
Group:		Applications/Databases
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	%{name} = %{version}-%{release}
Requires:	java(servlet)
Requires:	rc-scripts
Provides:	group(hsqldb)
Provides:	user(hsqldb)
Obsoletes:	hsqldb-server <= 1.8.1.1-1

%description -n hsqldb
HSQLDB server.

%description -n hsqldb -l pl.UTF-8
Serwer HSQLDB.

%prep
%setup -q -n %{srcname}
%undos build/build.xml
%patch0 -p0
%patch1 -p1
%patch2 -p1

# remove all binary libs
rm -f lib/hsqldb.jar
rm -f lib/servlet.jar

# create manual dir without apidocs
cp -a doc manual
rm -rf manual/src
cp -a index.html manual

%build
required_jars="\
	jsse/jsse \
	jsse/jnet \
	jsse/jcert \
	jdbc-stdext \
	junit \
	servlet-api \
"
CLASSPATH=$(build-classpath $required_jars)
export CLASSPATH

%ant -f build/build.xml hsqldb javadoc

%jar cf %{srcname}.src.jar -C src .

%install
rm -rf $RPM_BUILD_ROOT
# jar
install -d $RPM_BUILD_ROOT%{_javadir}
install lib/%{srcname}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}-%{version}.jar
ln -s  %{srcname}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{srcname}.jar

# bin
install -d $RPM_BUILD_ROOT%{_bindir}
install bin/runUtil.sh $RPM_BUILD_ROOT%{_bindir}/%{srcname}RunUtil

# sysv init
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install bin/%{srcname} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{srcname}

# config
install -d $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/%{srcname}

# serverconfig
install -d $RPM_BUILD_ROOT%{_localstatedir}/lib/%{srcname}
install %{SOURCE2} $RPM_BUILD_ROOT%{_localstatedir}/lib/%{srcname}/server.properties
install %{SOURCE3} $RPM_BUILD_ROOT%{_localstatedir}/lib/%{srcname}/webserver.properties
install %{SOURCE4} $RPM_BUILD_ROOT%{_localstatedir}/lib/%{srcname}/sqltool.rc

# lib
install -d $RPM_BUILD_ROOT%{_localstatedir}/lib/%{srcname}/lib
install lib/functions $RPM_BUILD_ROOT%{_localstatedir}/lib/%{srcname}/lib
ln -sf %{_javadir}/servlet-api.jar $RPM_BUILD_ROOT%{_localstatedir}/lib/%{srcname}/lib/servlet.jar

# data
install -d $RPM_BUILD_ROOT%{_localstatedir}/lib/%{srcname}/data

# source
install -d $RPM_BUILD_ROOT%{_javasrcdir}
cp -a %{srcname}.src.jar $RPM_BUILD_ROOT%{_javasrcdir}/%{srcname}.src.jar

# demo
install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}
install demo/*.sh 	$RPM_BUILD_ROOT%{_examplesdir}/%{name}
install demo/*.html 	$RPM_BUILD_ROOT%{_examplesdir}/%{name}

# javadoc
install -d $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
cp -a doc/src/* $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
ln -s %{srcname}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{srcname} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%pre -n hsqldb
%groupadd -g 169 %{srcname}
%useradd -u 169 -g %{srcname} -s /bin/sh -d %{_localstatedir}/lib/%{srcname} %{srcname}

%post -n hsqldb
/sbin/chkconfig --add %{srcname}
%service %{srcname} restart

%preun -n hsqldb
if [ "$1" = "0" ]; then
	%service -q %{srcname} stop
	/sbin/chkconfig --del %{srcname}
fi

%postun -n hsqldb
if [ "$1" = "0" ]; then
	%userremove %{srcname}
	%groupremove %{srcname}
fi

%post javadoc
ln -nfs %{srcname}-%{version} %{_javadocdir}/%{srcname}

%files
%defattr(644,root,root,755)
%doc doc/hsqldb_lic.txt
%{_javadir}/%{srcname}.jar
%{_javadir}/%{srcname}-%{version}.jar

%files manual
%defattr(644,root,root,755)
%doc manual/*

%files javadoc
%defattr(644,root,root,755)
%{_javadocdir}/%{srcname}-%{version}
%ghost %{_javadocdir}/%{srcname}

%files source
%defattr(644,root,root,755)
%{_javasrcdir}/%{srcname}.src.jar

%files demo
%defattr(644,root,root,755)
%dir %{_examplesdir}/%{name}
%{_examplesdir}/%{name}/*.html
%attr(755,root,root) %{_examplesdir}/%{name}/*.sh

%files -n hsqldb
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/hsqldbRunUtil
%attr(754,root,root) /etc/rc.d/init.d/%{srcname}
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{srcname}
%dir %{_localstatedir}/lib/%{srcname}
%attr(755,hsqldb,hsqldb) %{_localstatedir}/lib/%{srcname}/data
%{_localstatedir}/lib/%{srcname}/lib
%{_localstatedir}/lib/%{srcname}/server.properties
%{_localstatedir}/lib/%{srcname}/webserver.properties
%attr(600,hsqldb,hsqldb) %{_localstatedir}/lib/%{srcname}/sqltool.rc

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: java-hsqldb.spec,v $
Revision 1.38  2010/05/14 22:04:08  sparky
- BR: rpm-javaprov

Revision 1.37  2010/04/24 17:53:05  pawelz
- -source subpackage

Revision 1.36  2010/04/24 17:26:34  pawelz
- don't force java5-sun, it builds with newer, at least with icedtea6

Revision 1.35  2010/04/24 16:54:29  pawelz
- verbose %files

Revision 1.34  2010/04/24 16:50:15  pawelz
- install demo in %{_examplesdir}
- -demo G: Documentation

Revision 1.33  2010/04/24 16:45:26  pawelz
- -server subpackage renamed to -n hsqldb
- added Obsoletes tags
- rel 2

Revision 1.32  2010/04/24 16:34:59  pawelz
- renamed from hsqldb.spec

Revision 1.31  2010/04/24 03:27:14  pawelz
- BR: rpmbuild(macros) >= 1.556 for %use_jdk stuff

Revision 1.30  2010/04/24 03:26:33  pawelz
- don't package binary version. Force java5-sun jdk
- build fixes
- updated java deps
- use %undos macro

Revision 1.29  2009/11/30 00:53:07  sparky
- BR: unzip

Revision 1.28  2009/10/07 17:41:43  glen
- add javadoc patch (reported by pawelz)

Revision 1.27  2009/10/06 09:46:25  pawelz
- up to 1.8.1.1
- deps are case sensitive for rpm (but not for rpmbuild (?))
- fixed link to servlet.jar
- more TODO

Revision 1.26  2009/10/06 08:04:59  pawelz
- reverted last commit. It's to early for development :/

Revision 1.25  2009/10/06 07:46:47  pawelz
- reverted TODO. Break build, do not ignore error. It is confusing.

Revision 1.24  2009/10/06 07:42:13  pawelz
- server subpackage:
  updated deps (servlet -> java(servlet)
  dropped C: hsqldb < 1.8.0.7-0.4. It is implied by strict R: %{name}

Revision 1.23  2009/10/06 07:38:22  pawelz
- updated BRs (servlet -> java(servlet), junit -> java-junit)
- commented out Patch2 (what happend to the patch itself?)
- dropped TODO. It builds with jdk 1.6

Revision 1.22  2007/12/30 22:49:03  glen
- rel 2

Revision 1.21  2007-12-30 21:58:39  glen
- updated to 1.8.0.9, resolves CVE-2007-4575

Revision 1.20  2007-12-29 00:43:35  glen
- rel 3

Revision 1.19  2007-12-12 20:36:33  qboosh
- updated bcond desc
- don't use non-existing epoch
- no macro in Conflicts with old package
- pl for -server
- unified License format

Revision 1.18  2007-12-12 20:07:12  glen
- unify java package
- binary vs build is detected automatically
- rel 2

Revision 1.17  2007-10-23 14:57:03  glen
- rel 1

Revision 1.16  2007/09/19 15:01:21  adamg
- updated to 1.8.0.8

Revision 1.15  2007/03/05 21:07:53  glen
- typo

Revision 1.14  2007/03/03 15:19:25  glen
- AC-branch merge

Revision 1.13  2007/03/01 22:15:33  glen
- initscript integration for -server

Revision 1.12  2007/03/01 21:59:25  darekr
- missing dir

Revision 1.11  2007/03/01 21:53:41  glen
- separated -server

Revision 1.10  2007/03/01 21:48:10  glen
- add binary bcond, can now package on ac

Revision 1.9  2007/03/01 21:15:46  glen
- cleanups

Revision 1.8  2007/02/12 21:23:55  glen
- tabs in preamble

Revision 1.7  2007/02/12 01:06:45  baggins
- converted to UTF-8

Revision 1.6  2007/01/27 10:03:07  qboosh
- pl
- killed subshells (needs checking and bashism fix)

Revision 1.5  2007/01/23 23:49:08  glen
- pldize user/groupadd

Revision 1.4  2007/01/23 23:44:13  glen
- builds with java-sun-1.5

Revision 1.3  2007/01/23 23:38:54  glen
- typo

Revision 1.2  2007/01/23 23:35:39  glen
- deps satisfied but build fails with java-sun-1.6

Revision 1.1  2007/01/23 23:14:25  glen
- NFY, based on jpackage spec
